/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 331
#ifdef HAVE_CONFIG_H
#line 331
# include <config.h>
#line 331
#endif
#line 331
#include <sys/types.h>
#line 331

#line 331
#include "mailfromd.h"
#line 331
#include "prog.h"
#line 331
#include "builtin.h"
#line 331

#line 331

#line 769 "../../src/builtin/snarf.m4"

#line 1 "dns.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include "srvcfg.h"
#include "global.h"

static size_t max_ptr = MAX_DNS_PTR;
static size_t max_a = MAX_DNS_A;
static size_t max_mx = MAX_DNS_MX;
static struct mu_cfg_param dns_cfg_param[] = {
	{ "max-dns-reply-a", mu_cfg_size, &max_a, 0, NULL,
	  N_("Maximum number of A records in a DNS reply.") },
	{ "max-dns-reply-ptr", mu_cfg_size, &max_a, 0, NULL,
	  N_("Maximum number of PTR records in a DNS reply.") },
	{ "max-dns-reply-mx", mu_cfg_size, &max_mx, 0, NULL,
	  N_("Maximum number of MX records in a DNS reply.") },
	{ NULL }
};


void
#line 38
bi_primitive_hostname(eval_environ_t env)
#line 38

#line 38

#line 38 "dns.bi"
{
#line 38
	
#line 38

#line 38

#line 38
char * MFL_DATASEG string;
#line 38
        
#line 38
get_string_arg(env, 0, &string);
#line 38
        
#line 38

#line 38
        adjust_stack(env, 1);
#line 38

#line 38

#line 38
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 38
		prog_trace(env, "primitive_hostname %s",string);;
#line 38

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 44
		(
#line 44
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("cannot resolve IP %s"),string)
#line 44
)
#line 47
;
	
	pushs(env, hbuf);
	free(hbuf);
}

#line 52
        env_function_cleanup_flush(env, NULL);
#line 52
	return;
#line 52
}

void
#line 54
bi_primitive_resolve(eval_environ_t env)
#line 54

#line 54

#line 54 "dns.bi"
{
#line 54
	
#line 54

#line 54
long __bi_argcnt;
#line 54
char * MFL_DATASEG string;
#line 54
        char * MFL_DATASEG domain;
#line 54
        
#line 54
get_string_arg(env, 1, &string);
#line 54
        get_string_arg(env, 2, &domain);
#line 54
        
#line 54
get_numeric_arg(env, 0, &__bi_argcnt);
#line 54
        adjust_stack(env, __bi_argcnt + 1);
#line 54

#line 54

#line 54
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 54
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 54

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 61
		(
#line 61
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s.%s"),string,domain)
#line 61
)
#line 63
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 66
		(
#line 66
	env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s"),string)
#line 66
)
#line 68
;
	}
	pushs(env, ipstr);
	free(ipstr);
}

#line 73
        env_function_cleanup_flush(env, NULL);
#line 73
	return;
#line 73
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 87
bi_dns_getaddr(eval_environ_t env)
#line 87

#line 87

#line 87 "dns.bi"
{
#line 87
	
#line 87

#line 87

#line 87
char * MFL_DATASEG string;
#line 87
        
#line 87
get_string_arg(env, 0, &string);
#line 87
        
#line 87

#line 87
        adjust_stack(env, 1);
#line 87

#line 87

#line 87
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 87
		prog_trace(env, "dns_getaddr %s",string);;
#line 87

{
	GACOPYZ_UINT32_T *ipbuf;
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	ipbuf = xcalloc(max_a, sizeof(ipbuf[0]));
	dnstat = a_lookup(string, ipbuf, max_a, &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0; i < ipcount; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 109
do {
#line 109
  char *__s = q;
#line 109
  heap_obstack_grow(env, __s, strlen(__s));
#line 109
} while (0);
		}
		free(ipbuf);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 113
do {
#line 113
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 113
  goto endlab;
#line 113
} while (0);
	}
	case dns_not_found:
		free(ipbuf);
		do {pushs(env, "");
#line 117
goto endlab;
#line 117
} while (0);
	default:
		free(ipbuf);
		(
#line 120
	env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getaddr", _("failed to get A record for %s"),string)
#line 120
);
#line 122
	}
}
endlab:
#line 124
        env_function_cleanup_flush(env, NULL);
#line 124
	return;
#line 124
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 132
bi_dns_getname(eval_environ_t env)
#line 132

#line 132

#line 132 "dns.bi"
{
#line 132
	
#line 132

#line 132

#line 132
char * MFL_DATASEG ipstr;
#line 132
        
#line 132
get_string_arg(env, 0, &ipstr);
#line 132
        
#line 132

#line 132
        adjust_stack(env, 1);
#line 132

#line 132

#line 132
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 132
		prog_trace(env, "dns_getname %s",ipstr);;
#line 132

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char **names;

		if (!(inet_aton(ipstr, &addr)))
#line 139
		(
#line 139
	env_throw_bi(env, mfe_invip, "dns_getname", _("invalid IP: %s"),ipstr)
#line 139
)
#line 141
;

	names = xcalloc(max_ptr, sizeof(names[0]));
	dnstat = ptr_lookup(addr, names, max_ptr, &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i;
		size_t ncount;

		for (ncount = 0; ncount < max_ptr && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		heap_obstack_begin(env);
		for (i = 0; i < ncount; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 159
do {
#line 159
  char *__s = names[i];
#line 159
  heap_obstack_grow(env, __s, strlen(__s));
#line 159
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		for (; i < ncount; i++) 
			free(names[i]);
		free(names);
		
#line 166
do {
#line 166
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 166
  goto endlab;
#line 166
} while (0);
	}
	case dns_not_found:
		free(names);
		do {pushs(env, "");
#line 170
goto endlab;
#line 170
} while (0);
	default:
		free(names);
		(
#line 173
	env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getname", _("failed to get PTR record for %s"),ipstr)
#line 173
);
#line 175
	}
}
endlab:
#line 177
        env_function_cleanup_flush(env, NULL);
#line 177
	return;
#line 177
}

void
#line 179
bi_primitive_hasmx(eval_environ_t env)
#line 179

#line 179

#line 179 "dns.bi"
{
#line 179
	
#line 179

#line 179

#line 179
char *  string;
#line 179
        
#line 179
get_string_arg(env, 0, &string);
#line 179
        
#line 179

#line 179
        adjust_stack(env, 1);
#line 179

#line 179

#line 179
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 179
		prog_trace(env, "primitive_hasmx %s",string);;
#line 179

{
	struct mxbuf mxbuf;
	mf_status mxstat;

	mxbuf.mx_flags = 0;
	mxstat = getmx(string, &mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 187
		(
#line 187
	env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("cannot get MX records for %s"),string)
#line 187
)
#line 190
;
	mxbuf_free(&mxbuf);
	if (mxstat == mf_success) {
		
#line 193
do {
#line 193
  push(env, (STKVAL) (1));
#line 193
  goto endlab;
#line 193
} while (0);
	}
	
#line 195
do {
#line 195
  push(env, (STKVAL) (0));
#line 195
  goto endlab;
#line 195
} while (0);
}
endlab:
#line 197
        env_function_cleanup_flush(env, NULL);
#line 197
	return;
#line 197
}

void
#line 199
bi_getmx(eval_environ_t env)
#line 199

#line 199

#line 199 "dns.bi"
{
#line 199
	
#line 199

#line 199
long __bi_argcnt;
#line 199
char * MFL_DATASEG domain;
#line 199
        long  no_resolve;
#line 199
        
#line 199
get_string_arg(env, 1, &domain);
#line 199
        get_numeric_arg(env, 2, &no_resolve);
#line 199
        
#line 199
get_numeric_arg(env, 0, &__bi_argcnt);
#line 199
        adjust_stack(env, __bi_argcnt + 1);
#line 199

#line 199

#line 199
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 199
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? no_resolve : 0));;
#line 199

{
	mf_status mxstat;

	if (((__bi_argcnt > 1) ? no_resolve : 0)) {
		GACOPYZ_UINT32_T *ipbuf;
		size_t ipcount;

		ipbuf = xcalloc(max_mx, sizeof(ipbuf[0]));
		mxstat = getmxip(domain, ipbuf, max_mx, &ipcount);
		if (!mf_resolved(mxstat)) {
			free(ipbuf);
			(
#line 211
	env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain)
#line 211
);
#line 213
		}
		if (mxstat == mf_not_found) {
			free(ipbuf);
			do {pushs(env, "");
#line 216
goto endlab;
#line 216
} while (0);
		} else {
			int i;
			
			heap_obstack_begin(env);
			for (i = 0; i < ipcount; i++) {
				struct in_addr s;
				s.s_addr = htonl(ipbuf[i]);
				
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 227
do {
#line 227
  char *__s = inet_ntoa(s);
#line 227
  heap_obstack_grow(env, __s, strlen(__s));
#line 227
} while (0);
			}
			free(ipbuf);
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 231
do {
#line 231
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 231
  goto endlab;
#line 231
} while (0);
		}
	} else {
		struct mxbuf mxbuf;

		mxbuf.mx_max = max_mx;
		mxbuf.mx_flags = MXF_MAX;
		mxstat = getmx(domain, &mxbuf);
		if (!mf_resolved(mxstat)) {
			mxbuf_free(&mxbuf);
			(
#line 241
	env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain)
#line 241
);
#line 243
		}
		if (mxstat == mf_not_found) {
			mxbuf_free(&mxbuf);
			do {pushs(env, "");
#line 246
goto endlab;
#line 246
} while (0);
		} else {
			int i;
		
			heap_obstack_begin(env);
			for (i = 0; i < mxbuf.mx_cnt; i++) {
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 254
do {
#line 254
  char *__s = mxbuf.mx_buf[i];
#line 254
  heap_obstack_grow(env, __s, strlen(__s));
#line 254
} while (0);
			}
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			mxbuf_free(&mxbuf);
			
#line 258
do {
#line 258
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 258
  goto endlab;
#line 258
} while (0);
		}
	}
}
endlab:
#line 262
        env_function_cleanup_flush(env, NULL);
#line 262
	return;
#line 262
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error(_("INTERNAL ERROR at %s:%d: resolve_hostname returned "
			   "invalid IP address: %s"),
			 __FILE__, __LINE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 291
bi_primitive_ismx(eval_environ_t env)
#line 291

#line 291

#line 291 "dns.bi"
{
#line 291
	
#line 291

#line 291

#line 291
char *  domain;
#line 291
        char *  ipstr;
#line 291
        
#line 291
get_string_arg(env, 0, &domain);
#line 291
        get_string_arg(env, 1, &ipstr);
#line 291
        
#line 291

#line 291
        adjust_stack(env, 2);
#line 291

#line 291

#line 291
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 291
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 291

{
	GACOPYZ_UINT32_T *ipbuf;
	size_t ipcount;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
#line 300
		(
#line 300
	env_throw_bi(env, mfe_noresolve, "primitive_ismx", _("cannot resolve host name %s"),ipstr)
#line 300
)
;
	ip = ntohl(ip);

	ipbuf = xcalloc(max_mx, sizeof(ipbuf[0]));
	mxstat = getmxip(domain, ipbuf, max_mx, &ipcount);

	if (mxstat != mf_success) {
		free(ipbuf);
		(
#line 309
	env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_ismx", _("cannot get MXs for %s"),domain)
#line 309
);
#line 311
	}

	for (i = 0; i < ipcount; i++) {
		if (ipbuf[i] == ip) {
			rc = 1;
			break;
		}
	}
		
	free(ipbuf);
	
#line 321
do {
#line 321
  push(env, (STKVAL) (rc));
#line 321
  goto endlab;
#line 321
} while (0);
}
endlab:
#line 323
        env_function_cleanup_flush(env, NULL);
#line 323
	return;
#line 323
}

void
#line 325
bi_relayed(eval_environ_t env)
#line 325

#line 325

#line 325 "dns.bi"
{
#line 325
	
#line 325

#line 325

#line 325
char *  s;
#line 325
        
#line 325
get_string_arg(env, 0, &s);
#line 325
        
#line 325

#line 325
        adjust_stack(env, 1);
#line 325

#line 325

#line 325
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 325
		prog_trace(env, "relayed %s",s);;
#line 325

{
	
#line 327
do {
#line 327
  push(env, (STKVAL) (relayed_domain_p(s)));
#line 327
  goto endlab;
#line 327
} while (0);
}
endlab:
#line 329
        env_function_cleanup_flush(env, NULL);
#line 329
	return;
#line 329
}


#line 331
void
#line 331
dns_init_builtin()
#line 331
{
#line 331
	
#line 331
	#line 38 "dns.bi"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 54 "dns.bi"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_string);
#line 87 "dns.bi"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 132 "dns.bi"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 179 "dns.bi"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 199 "dns.bi"
va_builtin_install_ex("getmx", bi_getmx, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_number);
#line 291 "dns.bi"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_string);
#line 325 "dns.bi"
va_builtin_install_ex("relayed", bi_relayed, 0, dtype_number, 1, 0, 0|0, dtype_string);

#line 331 "dns.bi"
	
#line 331
	 mf_add_runtime_params(dns_cfg_param);
#line 331
	 
#line 331
}
#line 331 "dns.bi"

#line 333

#line 763 "../../src/builtin/snarf.m4"

#line 763

